"use strict";
goog.provide("Blockly.Blocks.fashionstar");
goog.require("Blockly.Blocks");

var FS_SENSOR_HUE = 120;
var FS_RGB_MATRIX_HUE = 120;


/********************************************
Seeed 传感器
*********************************************/

// 传感器-超声波测距
Blockly.Blocks.Seeed_Ultrasonic = {
  init: function() {
    this.setColour(FS_SENSOR_HUE);
    this.appendDummyInput("")
    .appendField(Blockly.Seeed_Ultrasonic_Read);
    this.appendValueInput("PIN", Number)
    .setCheck(Number)
    .appendField(Blockly.MIXLY_PIN)
    .setAlign(Blockly.ALIGN_RIGHT);
    this.setInputsInline(true);
    this.setOutput(true);
  }
}

// 传感器-PAJ7620手势识别传感器-更新数据
Blockly.Blocks.Seeed_PAJ7620_Gesture_Update = {
  init: function() {
   this.setColour(FS_SENSOR_HUE);
   this.appendDummyInput("")
   .appendField(Blockly.Seeed_PAJ7620_Gesture_Update);
   this.setPreviousStatement(true);
   this.setNextStatement(true);
   this.setInputsInline(true);
 }
};

// 传感器-PAJ7620手势识别传感器-判断数据
Blockly.Blocks.Seeed_PAJ7620_Read_Gesture = {
  init: function() {
    this.setColour(FS_SENSOR_HUE);
    this.appendDummyInput("")
    .appendField(Blockly.Seeed_PAJ7620_Read_Gesture);
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown([
      [Blockly.PAJ7620_Gesture_UP, "data == GES_UP_FLAG"], 
      [Blockly.PAJ7620_Gesture_DOWN, "data == GES_DOWN_FLAG"],
      [Blockly.PAJ7620_Gesture_LEFT, "data == GES_LEFT_FLAG"],
      [Blockly.PAJ7620_Gesture_RIGHT, "data == GES_RIGHT_FLAG"],
      [Blockly.PAJ7620_Gesture_FORWARD, "data == GES_FORWARD_FLAG"],
      [Blockly.PAJ7620_Gesture_BACKWARD, "data == GES_BACKWARD_FLAG"],
      [Blockly.PAJ7620_Gesture_CLOCKWISE, "data == GES_CLOCKWISE_FLAG"],
      [Blockly.PAJ7620_Gesture_COUNT_CLOCKWISE, "data == GES_COUNT_CLOCKWISE_FLAG"],
      [Blockly.PAJ7620_Gesture_WAVE, "data == GES_WAVE_FLAG"]
      ]), "PAJ7620_Gesture_TYPE");
    this.setInputsInline(true);
    this.setOutput(true);
  }
};

//传感器-LSM6DS3六轴陀螺仪-获取数据
Blockly.Blocks.LSM6DS3 = {
  init: function() {
    this.setColour(FS_SENSOR_HUE);
    this.appendDummyInput("")
    .appendField(Blockly.Seeed_LSM6DS3);
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown([
      [Blockly.LSM6DS3_Accel_X, "mpu_lsm6ds3.readFloatAccelX()"], 
      [Blockly.LSM6DS3_Accel_Y, "mpu_lsm6ds3.readFloatAccelY()"], 
      [Blockly.LSM6DS3_Accel_Z, "mpu_lsm6ds3.readFloatAccelZ()"],
      [Blockly.LSM6DS3_Gyro_X, "mpu_lsm6ds3.readFloatGyroX()"],
      [Blockly.LSM6DS3_Gyro_Y, "mpu_lsm6ds3.readFloatGyroY()"],
      [Blockly.LSM6DS3_Gyro_Z, "mpu_lsm6ds3.readFloatGyroZ()"],
      [Blockly.LSM6DS3_readTempC, "mpu_lsm6ds3.readTempC()"],
      [Blockly.LSM6DS3_readTempF, "mpu_lsm6ds3.readTempF()"]
      ]), "LSM6DS3_TYPE");
    this.setInputsInline(true);
    this.setOutput(true);
  }
};


/********************************************
Seeed 8×8 RGB 点阵
*********************************************/

/*
Blockly.Blocks.Seeed_color = {
  init: function() {
    var led_color = ['#ff0000','#ff9900','#ffff00','#33ff33','#33ffff',
                     '#3366ff','#6600cc','#ff99ff','#ffffff','#000000'
                     ];
    var color_detected = new Blockly.FieldColour('#000000');
    color_detected.setColours(led_color).setColumns(5);

    this.setColour(Blockly.Blocks.grove_rgb_matrix.HUE);
    this.appendDummyInput()
        .appendField(color_detected, "LEDColorDetect");
    this.setOutput(true, Number);
    this.setInputsInline(true);
  }
};
*/

Blockly.Blocks.Seeed_display_Matrix_LedArray = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
      .appendField(new Blockly.FieldTextInput("RGBArray"), "VAR");
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_11"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_12"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_13"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_14"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_15"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_16"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_17"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_18"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_21"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_22"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_23"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_24"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_25"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_26"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_27"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_28"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_31"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_32"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_33"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_34"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_35"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_36"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_37"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_38"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_41"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_42"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_43"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_44"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_45"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_46"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_47"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_48"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_51"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_52"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_53"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_54"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_55"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_56"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_57"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_58"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_61"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_62"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_63"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_64"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_65"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_66"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_67"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_68"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_71"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_72"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_73"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_74"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_75"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_76"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_77"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_78"
      );
    this.appendDummyInput("")
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_81"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_82"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_83"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_84"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_85"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_86"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_87"
      )
      .appendField(
        new Blockly.FieldColour("#000000").setColours(led_color).setColumns(5),
        "RGB_88"
      );
    this.setOutput(true, Number);
    this.setTooltip();
  },
};

Blockly.Blocks.Seeed_display_Matrix_LedArray1 = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
      .appendField(new Blockly.FieldTextInput("LedArray"), "VAR")
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(
        new Blockly.FieldColour("#ff0000").setColours(led_color).setColumns(5),
        "colour"
      );
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a81")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a82")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a83")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a84")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a85")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a86")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a87")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a88");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a71")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a72")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a73")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a74")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a75")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a76")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a77")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a78");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a61")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a62")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a63")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a64")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a65")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a66")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a67")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a68");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a51")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a52")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a53")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a54")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a55")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a56")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a57")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a58");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a41")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a42")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a43")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a44")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a45")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a46")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a47")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a48");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a31")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a32")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a33")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a34")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a35")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a36")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a37")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a38");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a21")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a22")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a23")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a24")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a25")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a26")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a27")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a28");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a11")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a12")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a13")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a14")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a15")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a16")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a17")
      .appendField(new Blockly.FieldCheckbox("FALSE"), "a18");
    this.setOutput(true, Number);
    this.setTooltip("");
  },
};

// 显示图像
Blockly.Blocks["Seeed_display_image"] = {
  init: function () {
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("image")
      .setCheck(null)
      .appendField(Blockly.SEEED_DISPLAY_IMAGE);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

//画点
Blockly.Blocks["Seeed_draw_points"] = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    var color_detected = new Blockly.FieldColour("#ff0000");
    color_detected.setColours(led_color).setColumns(5);
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("abscissa")
      .setCheck(null)
      .appendField(Blockly.SEEED_DRAWPIXEL)
      .appendField(Blockly.SEEED_POSX);
    this.appendValueInput("ordinate")
      .setCheck(null)
      .appendField(Blockly.SEEED_POSY);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(color_detected, "color")
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

// 显示清屏
Blockly.Blocks["Seeed_clear_screen"] = {
  init: function () {
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendDummyInput().appendField(Blockly.SEEED_DISPLAY_CLEAR);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

var predefined_images = [
  ["smile", "0"],
  ["laugh", "1"],
  ["sad", "2"],
  ["mad", "3"],
  ["angry", "4"],
  ["cry", "5"],
  ["greedy", "6"],
  ["cool", "7"],
  ["shy", "8"],
  ["awkward", "9"],
  ["heart", "10"],
  ["small heart", "11"],
  ["broken heart", "12"],
  ["waterdrop", "13"],
  ["flame", "14"],
  ["creeper", "15"],
  ["mad creeper", "16"],
  ["sword", "17"],
  ["wooden sword", "18"],
  ["crystal sword", "19"],
  ["house", "20"],
  ["tree", "21"],
  ["flower", "22"],
  ["umbrella", "23"],
  ["rain", "24"],
  ["monster", "25"],
  ["crab", "26"],
  ["duck", "27"],
  ["rabbit", "28"],
  ["cat", "29"],
  ["up", "30"],
  ["down", "31"],
  ["left", "32"],
  ["right", "33"],
  ["smile face", "34"],
];

//显示内置图案
Blockly.Blocks["Seeed_display_pattern"] = {
  init: function () {
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_SHOW_BUILT_IN_PATTERNS)
      .appendField(new Blockly.FieldDropdown(predefined_images), "number")
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

// 显示字符串
Blockly.Blocks["Seeed_display_string"] = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    var color_detected = new Blockly.FieldColour("#ff0000");
    color_detected.setColours(led_color).setColumns(5);
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("string")
      .setCheck(null)
      .appendField(Blockly.SEEED_DISPLAY_STRING);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(color_detected, "color")
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

// 显示条形
Blockly.Blocks["Seeed_display_Bar"] = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    var color_detected = new Blockly.FieldColour("#ff0000");
    color_detected.setColours(led_color).setColumns(5);
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("num")
      .setCheck(null)
      .appendField(Blockly.SEEED_PLOT_BAR);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(color_detected, "color")
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("范围0-32");
    this.setHelpUrl("");
  },
};

// 使用指定颜色显示波形
Blockly.Blocks["Seeed_display_waveform"] = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    var color_detected = new Blockly.FieldColour("#ff0000");
    color_detected.setColours(led_color).setColumns(5);
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_DISPLAY_WAVEFORM)
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(color_detected, "color")
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

// 显示内置动画
Blockly.Blocks["Seeed_show_built_in_animation"] = {
  init: function () {
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_SHOW_BUILT_IN_ANIMATION)
      .appendField(
        new Blockly.FieldDropdown([
          ["big clockwise", "0"],
          ["small clockwise", "1"],
          ["rainbow cycle", "2"],
          ["fire", "3"],
          ["walking child", "4"],
          ["broken heart", "5"],
        ]),
        "num"
      )
      .appendField(Blockly.SEEED_DISPLAY_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};

// 使用指定颜色刷屏
Blockly.Blocks["Seeed_swipe"] = {
  init: function () {
    var led_color = [
      "#ff0000",
      "#ff9900",
      "#ffff00",
      "#33ff33",
      "#33ffff",
      "#3366ff",
      "#6600cc",
      "#ff99ff",
      "#ffffff",
      "#000000",
    ];
    var color_detected = new Blockly.FieldColour("#ff0000");
    color_detected.setColours(led_color).setColumns(5);
    this.setColour(FS_RGB_MATRIX_HUE);
    this.appendDummyInput("")
    .appendField(Blockly.SEEED_SWIPE);
    this.appendValueInput("display_time")
      .setCheck(null)
      .appendField(Blockly.SEEED_COLOUR)
      .appendField(color_detected, "color")
      .appendField(Blockly.SEEED_REFRESH_TIME);
    this.appendDummyInput()
      .appendField(Blockly.SEEED_DISPLAY_MODE)
      .appendField(
        new Blockly.FieldDropdown([
          [Blockly.SEEED_CYCLE_DISPLAY, "true"],
          [Blockly.SEEED_SHOW_ONCE, "false"],
        ]),
        "mode"
      );
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
    this.setHelpUrl("");
  },
};